/**
 * @(#)dataLoader.java
 *
 * Created on July 26, 2000, 1:08 PM
 */

/**
 *
 * @author  furyhawk <lookmeow@magix.com.sg>
 * @author  Raimar Falke <rf13@inf.tu-dresden.de>
 * @author  Michael Grundel
 * @version 0.11
 */


/**
   ********************************************************************
 CivLog - Copyright (C) 2000 - Wong Teck Meng
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
**********************************************************************
                                                                      */

//package CivLogData;

import java.util.*;
import java.io.*;
import java.io.File;

//import java.awt.*;
//import java.awt.event.*;

import javax.swing.*;

public class CivLogData extends Object {

  /** I still confused where to use static */

  /**
   * Mappes from EntryKey to CivLogDataEntry.
   */
  public static Hashtable civscore;
  public static String playerNames[];
  public static boolean playerSelected[];
  public static int numOfPlayerSelected;

  /** Records num of player, start year, end year, scale factors */
  /** TODO: What if two files are loaded? (one after another) */
  public static int numofPlayers  = 0;
  public static int startYear     = -4000;
  public static int endYear       = 2000;
  public static int currentPlayer = 0;

  /** maximum */
  /** scale factor for individual player is possible, vectorized it */
  public static int maxPop          = 0;
  public static int maxBnp          = 0;
  public static int maxMfg          = 0;
  public static int maxCities       = 0;
  public static int maxTechs        = 0;
  public static int maxMunits       = 0;
  public static int maxSettlers     = 0;
  public static int maxWonders      = 0;
  public static int maxTechout      = 0;
  public static int maxLandArea    = 0;
  public static int maxSettledArea = 0;
  public static int maxPollution    = 0;
  public static int maxLiteracy     = 0;
  public static int maxSpaceship    = 0;


  /** JFrame for Message Dialog */
  static JFrame frame;


  /** Creates new CivLogData */
  public CivLogData (JFrame pframe) {
    /** is super automatically called if not included */
    super ();

    Debug.trace ( "CivLogData.CivLogData(): initializing" );

    /** default */
    int numofPlayers = 0;
    int startYear    = -4000;
    int endYear      = 2000;
    
	civscore = new Hashtable();

    /** assign parent frame */
    frame = pframe;
    Debug.trace ( "CivLogData.CivLogData(): done" );
  }
  
  public static int getNumPlayers () {
    return numofPlayers;
  }
  
  public static void setNumPlayers (int number) {
    numofPlayers = number;
  }
  
  /** don't be fool by the get, it set data also */
  
  // this get_entry was the main cause for the slow loading
  // reason: for each line in the logfile it iterated through the whole
  // Vector, which meant O(N*N)
  // new Implementation uses 2 Hash-lookups per line, meaning O(N*const*2) = O(N)
  // result: 2 seconds instead of 20 on one of my logfiles - Michael Grundel
  // Note: Raimar Falke's data structure is currently used
  static CivLogDataEntry get_entry (int year, int player) {
    CivLogDataEntry result = find_entry (year,player);
    
    if (result==null)
    {
      /** nothing found -> create new one */
      result = new CivLogDataEntry (year, player);
      EntryKey key = new EntryKey (year,player);
      civscore.put (key,result);
    }
    
    return result;
  }

  static CivLogDataEntry find_entry (int year, int player) {
    EntryKey key = new EntryKey (year,player);

    return (CivLogDataEntry)civscore.get (key);
  }

  /** why does it had to be static to be called from CivLogFrame.jmiOpenActionPerformed? */
  // I removed static and it works
  // if in the future we want to display different games (logs) simultaneously
  // in different graphs then this class will have to be changed to non-static
  // data-members anyway (i dont know if this is a goal or not) - Michael

  /** assuming that old data is clear if load fail. */
  /** remember to set numofPlayers before every return().- to be obseleted?? */
  /** to be perfect?? */
  /** return load success or failure */

  public boolean dataLoader (File theFile, String filePath) {
    Debug.trace ( "CivLogData.dataLoader(): initializing......." );

    /** a big catch :) */
    /** this catch is too big, how to improve? */
    try {
      BufferedReader in = new BufferedReader (new FileReader (theFile));
      String line;

      line = in.readLine ();

      if (line != null) {
        Debug.trace ( "CivLogData.dataLoader(): parsing for FREECIV header" );
        if (line.startsWith ("#FREECIV SCORELOG")) {
          /** TODO: button change to loadme */
          //JOptionPane.showMessageDialog (frame,
          //"It is a Civlog File: " + filePath
          //+ "\nLoading.....Wait even after pressing OK"
          //);
          Debug.trace ( "CivLogData.dataLoader(): Loading Civlog File: "
                        + filePath );
        }
        else {
          JOptionPane.showMessageDialog (frame,
          "Not a Civlog File: " + filePath,
          "Error",
          JOptionPane.ERROR_MESSAGE
          );
          Debug.trace ( "ERROR: CivLogData.dataLoader(): Not a Civlog File: " + filePath );
          /** quit if no a civlog file */
          return (false);
        }
      }

      /** FIXME: add more checks */
      /** check for header and get rid to it */
      Debug.trace ( "CivLogData.dataLoader(): parsing data type header" );
      for (;;) {
        line = in.readLine ();
        if (line == null) {
          JOptionPane.showMessageDialog (frame,
          "Error while data type header is readed I",
          "Error",
          JOptionPane.ERROR_MESSAGE
          );
          Debug.trace ( "ERROR: CivLogData.dataLoader(): parsing type header I" );
          return (false);
        }
        StringTokenizer st = new StringTokenizer (line);
        if (st.countTokens () > 2) {
          /** shouldn't be */
          JOptionPane.showMessageDialog (frame,
          "Error while data type header is readed II",
          "Error",
          JOptionPane.ERROR_MESSAGE
          );
          Debug.trace ( "ERROR: CivLogData.dataLoader(): parsing type header II" );
          return (false);
        }
        /** get rid of first token */
        String abc = st.nextToken ();
        if ( abc.equalsIgnoreCase ("end") ) {
          /** every OK! goto next parse*/
          break;
        }
        /** this part is reductant at the moment */
        abc = st.nextToken ();
        /** maybe the following if() can be done more professionally */
        if ( ! (abc.equalsIgnoreCase ("pop") || abc.equalsIgnoreCase ("bnp")
        || abc.equalsIgnoreCase ("mfg") || abc.equalsIgnoreCase ("cities")
        || abc.equalsIgnoreCase ("techs") || abc.equalsIgnoreCase ("munits")
        || abc.equalsIgnoreCase ("settlers") || abc.equalsIgnoreCase ("wonders")
        || abc.equalsIgnoreCase ("techout") || abc.equalsIgnoreCase ("landarea")
        || abc.equalsIgnoreCase ("settledarea") || abc.equalsIgnoreCase ("pollution")
        || abc.equalsIgnoreCase ("literacy") || abc.equalsIgnoreCase ("spaceship")
        ) ) {
          JOptionPane.showMessageDialog (frame,
          "Error while data type header is parsed III",
          "Error",
          JOptionPane.ERROR_MESSAGE
          );
          Debug.trace ( "ERROR: CivLogData.dataLoader(): parsing data type header III" );
          return (false);
        }
      }

      /** clear everythings before reading in new data */
      /** I suppose .clear() clean the internal data also? */
      Debug.trace ( "CivLogData.dataLoader(): clearing old data" );
      civscore.clear ();

      /** reset value, use by paint function to flag whether the data is loaded */
      numofPlayers = 0;
      /** read in the lines and get no. of players */
      Debug.trace ( "CivLogData.dataLoader(): parsing players header" );

      Vector lines = new Vector ();

      for (;;) {
        line = in.readLine ();
        if (line == null) {
          JOptionPane.showMessageDialog (frame,
          "Error while players header is parsed",
          "Error",
          JOptionPane.ERROR_MESSAGE
          );
          Debug.trace ( "ERROR: CivLogData.dataLoader(): parsing players header" );
          return (false);
        }
        /** check for end of players header */
        if (line.startsWith ("end")) {
          /** everything OK! goto next parse */
          break;
        }
        lines.addElement (line);
      }

      playerNames = new String[lines.size ()];
      playerSelected = new boolean[lines.size ()];
      numOfPlayerSelected = 0;
      numofPlayers = lines.size ();

      for (int i=0; i<lines.size (); i++)
      {
        line = (String)lines.elementAt (i);

        int index = line.indexOf (" ");

        String playerNumber = line.substring (0,index);
        String playerName = line.substring (index);

        int playerNumberAsInt;

        try
        {
          playerNumberAsInt = Integer.parseInt (playerNumber);
        }
        catch (NumberFormatException nfe)
        {
          throw new RuntimeException ("Invalid format: "+
          playerNumber);
        }

        playerNames[playerNumberAsInt] = playerName;

      }

      /* initial condition */
      boolean checkStartYear = false;
      /** can someone help me to implemate a progress bar? */
      //int progress = 0;
      //JFrame ff = new JFrame();
      //ProgressMonitor progressMonitor = new ProgressMonitor(ff, "loading score log", "wait", 0, 2000);
      //progressMonitor.setMillisToPopup (100);
      //progressMonitor.setProgress(0);
      
      //Debug.trace ( "CivLogData.dataLoader(): loading progress....");

      //ProgressFrame progressFrame = new ProgressFrame (this, true);
      //Dimension dlgSize = progressFrame.getPreferredSize ();
      //Dimension frmSize = frame.getSize ();
      //Point loc = getLocation ();
      //progressFrame.setLocation ( (frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
      //progressFrame.setModal (true);
      //progressFrame.show ();

      /** FIXME: add more checks and optimize*/
      Debug.trace ( "CivLogData.dataLoader(): parsing values header......." );
      for (;;) {
        line = in.readLine ();
        if (line == null) {
          /** finished */
          //progressMonitor.close ();
          break;
        }
        //progress++;
        //progressMonitor.setProgress (progress);
        /** can this part be optimized?  It is allocating too much memory? */
        StringTokenizer st = new StringTokenizer (line);

        /** where will it go if throwed, out of for() or ??? */
        if (st.countTokens () < 4) {
          //progressMonitor.close ();
          throw new RuntimeException ("Not enough fields");
        }

        String typeStr   = st.nextToken ();
        String playerStr = st.nextToken ();
        String yearStr   = st.nextToken ();
        String valueStr  = st.nextToken ();

        int type, player, year;
        int value; /** area value range can be very big */

        try {
          type   = Integer.parseInt (typeStr);
          player = Integer.parseInt (playerStr);
          year   = Integer.parseInt (yearStr);
          value  = Integer.parseInt (valueStr);
        }
        /** where will it go if throwed, out of for() or ??? */
        catch (NumberFormatException nfe) {
          //progressMonitor.close ();
          throw new RuntimeException ("Illegal line " + line + nfe);
        }

        switch (type) {
          case Freeciv.POP:         maxPop         = Math.max (maxPop, value);
          break;
          case Freeciv.BNP:         maxBnp         = Math.max (maxBnp, value);
          break;
          case Freeciv.MFG:         maxMfg         = Math.max (maxMfg, value);
          break;
          case Freeciv.CITIES:      maxCities      = Math.max (maxCities, value);
          break;
          case Freeciv.TECHS:       maxTechs       = Math.max (maxTechs, value);
          break;
          case Freeciv.MUNITS:      maxMunits      = Math.max (maxMunits, value);
          break;
          case Freeciv.SETTLERS:    maxSettlers    = Math.max (maxSettlers, value);
          break;
          case Freeciv.WONDERS:     maxWonders     = Math.max (maxWonders, value);
          break;
          case Freeciv.TECHOUT:     maxTechout     = Math.max (maxTechout, value);
          break;
          case Freeciv.LANDAREA:    maxLandArea    = Math.max (maxLandArea, value);
          break;
          case Freeciv.SETTLEDAREA: maxSettledArea = Math.max (maxSettledArea, value);
          break;
          case Freeciv.POLLUTION:   maxPollution   = Math.max (maxPollution, value);
          break;
          case Freeciv.LITERACY:    maxLiteracy    = Math.max (maxLiteracy, value);
          break;
          case Freeciv.SPACESHIP:   maxSpaceship   = Math.max (maxSpaceship, value);
          break;
          default:           //progressMonitor.close ();
          JOptionPane.showMessageDialog (frame,
          "Error while values header is been parsed",
          "Error",
          JOptionPane.ERROR_MESSAGE
          );
          Debug.trace ( "ERROR: CivLogData.dataLoader(): parsing values header" );
          return (false);
        }

        if (!checkStartYear) {
          startYear = year;
          checkStartYear = true;
        }

        endYear = year;
        /** I supposed clde is deleted once out of for() */
        CivLogDataEntry clde = get_entry (year, player);
        clde.set_data (type, value);
        //Debug.trace("\nValue: " + value); /* don't do it, it slowwww */
      }

      /** to exec this section, the previous ops should be OK! or else... */
      in.close ();

      JOptionPane.showMessageDialog (frame,
      "No. of players: " + numofPlayers
      + "\nStart Year: " + startYear
      + "\nEnd Year: " + endYear
      );
      Debug.trace ( "CivLogData.dataLoader(): No. of players: " + numofPlayers
      + "  Start Year: " + startYear
      + "  End Year: " + endYear
      );

    } catch (IOException e) {
      /** FIXME: Add more debugging features */
    }
    Debug.trace ( "CivLogData.dataLoader(): returning" );
    return (true);
  }

}